Issue 65039 - Legal review: mere aggregation of GNU GPL licensed dictionaries (ie. non-code data) into installation sets
Legal review: mere aggregation of GNU GPL licensed dictionaries (ie. non-code...
Product: lingucomponent
Classification: Code
Component: other
All All
: P2 Trivial with 18 votes (vote)
: ---
Assigned To: Martin Hollmichel
Depends on:
Blocks: 72416
  Show dependency treegraph
Reported: 2006-05-03 13:35 UTC by pavel
Modified: 2009-05-15 09:44 UTC (History)
17 users (show)

See Also:
Issue Type: TASK
Latest Confirmation in: ---
Developer Difficulty: ---


Note You need to log in before you can comment on or make changes to this issue.
Description pavel 2006-05-03 13:35:25 UTC
Czech spell checking dictionary (and also Danish) is licensed under GNU GPL.

We want to get it included. According to our opinion, we want to do "mere
aggregation" of the dictinary data with our installation sets. GNU GPL (in our
opinion) allows that:

In addition, mere aggregation of another work not based on the Program
with the Program (or with a work based on the Program) on a volume of
a storage or distribution medium does not bring the other work under
the scope of this License.

Can we get legal opinion on this?
Comment 1 ooolist2007 2006-05-09 20:09:45 UTC
This is an important issue, also for many other languages. Should me maybe 
just add people from Sun on Cc? Without that I guess this report will remain 
unanswered for the next few years... 
Comment 2 Martin Hollmichel 2006-05-10 04:50:11 UTC
dnaber: I'm the correct contact for this.
Comment 3 Andrea Pescetti 2006-08-09 18:38:27 UTC
Italian is also affected by this issue: although OOo ships with an Italian
dictionary (but without a thesaurus), we have a better Italian dictionary and a
thesaurus under the GPL license.

CCing myself and the maintainer of the GPLed Italian linguistic tools.
Comment 4 ooolist2007 2006-08-27 00:16:22 UTC
mh: What's the status of this issue? Currently the German dictionary is 
included in OOo, but not under the GPL but under a different license which 
allows distributing the word lists with software that uses OpenDocument as its 
primary format. This license does however not allow modification which 
basically makes it impossible to fix errors without the help of wordlist 
maintainer. This is not really acceptable. 
Comment 5 ooolist2007 2006-09-15 13:12:18 UTC
Just to summarize two very important points: 
1.) Including GPL'd dictionaries should be okay, as these are just lists of 
words (i.e. plain text files) which are loaded at runtime. *No* GPL'd code at 
all is involved. 
2.) Not distributing dictionaries is a *major* usability problem. Having 
DicOOo is nice but didn't prevent loads of user questions about how to make 
the German spellchecker work (back when it was not distributed yet). 
Comment 6 maison.godard 2006-10-11 07:12:46 UTC

1- Spellchecker is more than a list of words. It contains a .dic file, list of
words and affixes .aff file containing linguistic logic
creating this .aff file is  the tricky parts and it is absolutely understandable
it is released under licence

2- Despite the interpretation on the GPL, we can not package it among LGPL
content. Can we ?

3- using DicOOo allow to add dictionaries. many versions can be listed for a
given language (see german and recently french for example)

This legal issue is really important and yes has to be discussed
Comment 7 pavel 2006-10-11 08:43:14 UTC
Yes, it is important.

No, we should not discuss it. We must wait for legal review and this is all
about this issue ;-)
Comment 8 milek_pl 2006-12-17 13:00:46 UTC
How about asking authors to license the data under LGPL as well? This wouldn't
make much difference, would it? Polish dictionary (not shipped yet with OOo) is
at the same time GPL, LGPL, CC and MPL (
Comment 9 pavel 2006-12-17 13:08:43 UTC
milek_pl: so you are lucky.

Unfortunately there is no known way to ask dead authors, so this *is* an issue for some languages.
Comment 10 clytie 2006-12-22 08:55:55 UTC
This is also an issue for Vietnamese. Our existing Aspell dictionary (
vi/) is GPL, and the current effort to create a more advanced spellchecker will also be GPL.
Comment 11 pavel 2007-01-17 14:28:12 UTC
Should everyone file its own private bug regarding their dictionary now?
Comment 12 axelb 2007-02-20 11:37:21 UTC
Why not license OOo as GPL, then implementing lgpl-code should be no problem?
Comment 13 axelb 2007-02-20 11:46:47 UTC
We asked FSF if such an inclusion should be problematic, and the answear we got
bach was (passages marked ghk is from Gaute H. Kvalnes, a norwegian translator
of OOo):

 ghk> This issue seems to boil down to a meta-question on what
 ghk> "compatible licenses" really mean: When we combine GPL-ed and
 ghk> LGPL-ed code, do the individual parts of the source code keep
 ghk> their original licenses, or must they all be relicensed to GPL?

I think the answer to this is pretty staightforward, but please keep
in mind that I am not a lawyer, and that the information is possibly
not 100% complete, or that I may have misunderstood you.

 ghk> I can imagine two scenarios:

 ghk> 1. The LGPL-ed main part stays LGPL, while the module and the
 ghk> "one larger program" [1] is GPL-ed. In this case, I don't quite
 ghk> understand what the license on the program as a whole will
 ghk> cover.

This is indeed what happens as far as I can see.

If you combine them into one package, you should treat the overall
package as if it were GPL'ed -- that will always fulfill all the
necessary conditions for the LGPL'ed code, as well, which has more
permissions than GPL'ed code, but identical requirements.

I am not sure that I understand what you mean by "license on the
program as a whole" in this case. Do you mean the combined package or
do you mean something else?

Quite frankly: From your descriptions it does not seem clear why you
should not be allowed to distribute OpenOffice under LGPL with GPL'ed
dictionaries as long as you yourself treat the entire package as if it
were GPL'ed, which does not seem a problem from what you described as
your objectives.

Could you tell us who said that it was not possible to do so?

There may be a misunderstanding or misinformation worth clarifying.


I would suggest OOo sent a formal letter to fsf to let them legally confirm this
officially. It seeems to be a non-existent problem, that is: The dictionaries
should just be incorporated and shipped. End of story.
Comment 14 pavel 2007-02-20 12:10:19 UTC

Answer yourself:

if OOo is GNU GPL, can we link to non-GNU GPL licensed libraries?

Do we use any non-GPL libraries already?

Do you know what is "mere aggregation"?

The problem is NOT that simple as you draw it.
Comment 15 gaute 2007-02-20 12:34:29 UTC
I hesitated to add these comments to this issue, as it's a more radical 
approach than "mere aggregation".

However, let me explain the basic idea: The main part of the code stays LGPL 
like today, but is included into a larger GPL-ed program. It's possible for the 
main code to stay LGPL-ed, because LGPL is GPL compatible. But it would now 
also become possible to include additional GPL-ed components like dictionaries 
(even if not considered "mere aggregation").

As for non-GPL libraries, I don't know. Is that still a problem when the main 
part of the code remains LGPL?

(There are of course a number of GPL-compatible licenses which should pose no 
problem. I don't think that's what you're talking about, though. http:// )
Comment 16 Andrea Pescetti 2007-02-20 13:02:32 UTC
I received today, a few months after my request, an opinion by the Free Software
Foundation stating that the mere aggregation is feasible: "the executable
program and each dictionary/thesaurus would be considered as seperate works.
Therefore their licenses do not need to be compatible".

The full e-mail exchange is below.

  Date: Tue, 20 Feb 2007 03:15:09 -0500
  From: John Steele Scott via RT <licensing AT>
  To: pescetti
  Subject: [ #306930] and GPL dictionaries

> [pescetti - Fri Sep 15 09:59:36 2006]:
> Hi there,
> I would like to hear your opinion on a GPL/LGPL-related problem that we
> are studying for distribution of I'm going to post your
> answer in the ongoing discussion at
> The office suite can use a dictionary and/or a thesaurus,
> which is a simple data file in a specific format (i.e., there is no
> "source code" for it).
> Installation packages including both and a
> dictionary/thesaurus are common.
> The availability of the dictionary/thesaurus is checked at runtime and
> enables or disables the relevant functionality
> accordingly. So can work without the dictionary/theasurus
> and, conversely, the dictionary/thesaurus can be used without
> (e.g., as a data file for command-line
> spellcheckers/thesauri).
> Would it be possible to bundle LGPL(2.1)-licensed releases of
> and GPL(>=2)-licensed dictionaries in the same
> installation package?
> It is unclear whether this is "mere aggregation" of two packages that
> can be used independently, or whether placing the two components into
> one installation package, and the mutual benefits given by the bundle,
> forbid the interpretation as "mere aggregation".
> Thanks,
> Andrea.

Dear Andrea,

Thank you for your inquiry.

First, allow me to apologise for the delay in replying to your message.
In the case you have described above, the executable program and each
dictionary/thesaurus would be considered as seperate works. Therefore
their licenses do not need to be compatible.

Sorry once again for the late reply. Please note that this is not legal


Comment 17 Martin Hollmichel 2007-02-28 10:35:18 UTC
mere aggregation seems to be possible as long as they are separated packages,
e.g. have ooo-core-package1 (with LGPL code) and ooo-dict-package2 (with GPL
dictionary data) and ooo-core-package1 is not dependent to ooo-dict-package2.
This seem to be the easy case.

remaining problems may be:

1. is it sufficient to include in the THIRDPARTYLICENSEREADME.html: "This
software may include/aggregate the <bla>-dictionary under GPL license ..." ?

2. On Windows (and maybe other installers the Linux rpm and Solaris pkg) all the
packages have been combined to one big install blob. Is this still aggregation ?

As long as we ensure that we can easily detach the GPL'd dictionaries with a
simple mechanism from the overall install blob all concerns should be adressed.
Comment 18 Martin Hollmichel 2008-10-06 07:36:10 UTC
with the release of 3.0 the dictionaries comes as a separate package
(extensions) which can be installed and de-installed independently. This kind of
aggregation of GPLd dictionaries is now established process.
Dictionaries can be bundled with OOo if the extension package as a whole has
been committed to the source code repository (module dictionaries).
Comment 19 axelb 2009-05-14 23:30:08 UTC
This is not fixed, as I see it, as each user has to install the dictionaries
themselves. The dictionaries are published as extensions here, so the
requirements should be met to include them. Could this be reopened or do I have
to open a new report?
Comment 20 Martin Hollmichel 2009-05-15 05:28:22 UTC
@axelb: which dictionary is missing ?

prerequisite for dictionaries getting bundled/preinstalled is that the source of
the extensions is available at
Comment 21 axelb 2009-05-15 06:24:32 UTC
I was thinking abput the Norwegian dictionaries, they are here, with link to the
source code:

How do I add them to the mentioned svn-page?
Comment 22 axelb 2009-05-15 06:24:43 UTC
I was thinking about the Norwegian dictionaries, they are here, with link to the
source code:

How do I add them to the mentioned svn-page?
Comment 23 Mathias_Bauer 2009-05-15 07:20:35 UTC
Open an issue, put the link to the extension into the description and assign the
issue to me (or anybody else who volunteers to do the work - perhaps mh knows one).